C--------------------------------------------------------------------
C     Rechnen der asymmetrischen Einheit               
C--------------------------------------------------------------------
C
      SUBROUTINE fcalc1(mref,nref,IDX,F,
     $   masym,nasym,NPIX,IASYM,RDEN,rdint,av,pi)
C
C     *** rho(x,y,z)=1/Vc * sum_h sum_k sum_l (A cos(phi) + B sin(phi)
C     *** phi = 2 pi (hx + ky + lz)  see Int. Tables I (1969), p. 354 
C
C     *** masym=max. number of points in asymmetric unit
C     *** nasym= number of points in asymmetric unit
C     *** mref = max. number of reflections
C     *** nref = number of reflections
C     *** IASYM= array with coordinates (in pixel units) of pixels of a.u.
C     *** NPIX(3)=array with number of pixels alog cell-edges
C     *** RDEN() =array with density at each pixel
C     *** F()  = array with real and imaginary part of structure factors
C     *** rdint/av = total charge (in electrons/barnes) in unit cell.  
C
      IMPLICIT  none
      integer*4 masym,nasym,ia
      integer mref,nref,IASYM(3,masym),NPIX(3)
      real*8 RDEN(masym)
      real*8 rdint,av,pi,twopi,x,y,z,rd,phas
      real*8 F(2,mref)
      integer IDX(3,mref)
      integer nadd,nyes,j

      nadd=0
303   print *
      write(*,*) 'Should F(000) be added ? (0=yes)'
      read(*,'(BN,I5)',ERR=303) nadd
      if (nadd.eq.0) then 
	 print *, 'F(000)=', rdint*AV, 
     $            ' Ok ? (0=yes)'
         read(*,'(BN,I5)',ERR=303) nyes
         if (nyes.ne.0) then
	    print *,'Please input F(000):'
	    read(*,*,ERR=303) rdint
	    rdint=rdint/AV
            print *, 'To each pixel value ', rdint, ' is added.'
	 endif
      endif
      print *,'Calculation in progress  --  please wait ...'
      twopi=2*pi
C     *** real density(xyz)=1/(cell-vol) sum( A cos(2pi Hr) + B sin(2pi Hr) )
      do 10 ia=1,nasym
	rd=0.0d0
	x=IASYM(1,ia)/dfloat(npix(1))
	y=IASYM(2,ia)/dfloat(npix(2))
	z=IASYM(3,ia)/dfloat(npix(3))
	do 09 j=1,nref
          phas= twopi*(x*IDX(1,j) + y*IDX(2,j) + z*IDX(3,j))
          rd = rd + F(1,j)*dcos(phas) + F(2,j)*dsin(phas)
09      continue
	rden(ia)=rd/av
C       *** add F(000) ***
        if (nadd.eq.0) RDEN(ia)= RDEN(ia)+rdint
10    continue
      return
      END
C
