C
C--------------------------------------------------------------------
C     CALCULATE CONSTANTS FOR MAXENT PROCESS.
C--------------------------------------------------------------------
C
      SUBROUTINE PRECAL(jph,jpk,jpl,pi,rad,ca,cb,cg,sa,sb,sg,
     $   da,db,dg,dv,sv,as,bs,cs,ga,gb,gg,rh,rk,rl,av,
     $   rdint,sumBp,sumBm,rtBp,rtBm,CELL,NPIX)
C
      IMPLICIT none
      integer NPIX(3),jph,jpk,jpl
      real*8 CELL(6),pi,rad,ca,cb,cg,sa,sb,sg,
     $   da,db,dg,dv,sv,as,bs,cs,ga,gb,gg,rh,rk,rl,av,
     $   rdint,sumBp,sumBm,rtBp,rtBm
C
      PI=2*DACOS(0.0d0)
      RAD=PI/180.0
C
C*** CONSTANTS FOR RECIPROCAL SPACE ***
C
C     *** ca, cb, cg= cos (alpha, beta, gamma)
      CA=DCOS(RAD*CELL(4))
      CB=DCOS(RAD*CELL(5))
      CG=DCOS(RAD*CELL(6))
C     *** sa, sb, sg= sin (alpha, beta, gamma)
      SA=DSIN(RAD*CELL(4))
      SB=DSIN(RAD*CELL(5))
      SG=DSIN(RAD*CELL(6))
      DA=CB*CG-CA
      DB=CG*CA-CB
      DG=CA*CB-CG
      DV=1.0-CA*CA-CB*CB-CG*CG+2.0*CA*CB*CG
C     *** sv = V_cell / (a b c)
      SV=DSQRT(DV)
C     *** as, bs, cs = astar, bstar, cstar in reciprocal space
      AS=SA/(CELL(1)*SV)
      BS=SB/(CELL(2)*SV)
      CS=SG/(CELL(3)*SV)
C     *** ga, gb, gg = 2*cos(alphas, betas, gammas) in reciprocal space
      GA=2.0*DA/(SB*SG)
      GB=2.0*DB/(SG*SA)
      GG=2.0*DG/(SA*SB)
      RH=JPH*AS
      RK=JPK*BS
      RL=JPL*CS
C
C*** CONSTANTS FOR DENSITY DATA ***
C
C     *** av= cell volume
      AV=CELL(1)*CELL(2)*CELL(3)*SV
C     *** rdint= initial density of flat distribution
      RDINT=1/DFLOAT(NPIX(1)*NPIX(2)*NPIX(3)) 
      rtBp=sumBp * DFLOAT(NPIX(1)*NPIX(2)*NPIX(3)) / AV
      rtBm=sumBm * DFLOAT(NPIX(1)*NPIX(2)*NPIX(3)) / AV
C
      RETURN
      END
C
