C
C     save density of RDEN() array, together with symmetry information 
C     sum rho+ + rho- is saved, i.e. the total scattering density
C     of the positive and the negative density.
C  
      SUBROUTINE SAVEDEN(filden,
     $   masym,nasym,title,IASYM,RDENp,RDENm,CELL,NPIX
     $   ,nsym,ncen,nsub,IROT,RTRS,RSUB,rtBp,rtBm)
      IMPLICIT none
      integer*4 masym,nasym,ia
      real*8 RDENp(masym),RDENm(masym),CELL(6),RTRS(3,48),RSUB(3,4)
     $  ,rtBp,rtBm
      integer IASYM(3,masym),NPIX(3),IROT(3,3,48)
      integer nsym,ncen,nsub,i,j,isym,isub
      character title*200,filden*50
C
      OPEN(20,FILE=FILDEN,FORM='FORMATTED',
     $     STATUS='UNKNOWN', ACCESS='SEQUENTIAL')
1010  format(6F10.5)
1020  format(6i5)
1040  format(i7)
1070  format(f7.5,1x,f7.5,1x,f7.5)
1080  format(a,a,a)
C***  fuer VAX: 1080  format(a80)
1090  format(3(I4,1X),G21.6,2(1x,G21.6))
C   1100  format(12i5)       ! old symmetry operator format
1100  format(3(3i4,2x),2x,3(1x,f7.5)) 
      write(20,1080) title(1:80), title(81:160), title(161:200)
      write(20,1040) nasym
C
C     *** write density sum of asymmetric unit ***
      do 10 ia=1,nasym
        write(20,1090) (IASYM(i,ia),i=1,3),
     $    sngl( rtBp*RDENp(ia)+rtBm*RDENm(ia) ), 
     $    sngl(rtBp*RDENp(ia)), sngl(rtBm*RDENm(ia))
  10  continue
C
C     *** write cell constants ***
      write(20,1010) (CELL(i),i=1,6)
C
C     *** write pixel and symmetry information ***
      write(20,1020) (NPIX(i),i=1,3),nsym,ncen,nsub
C     *** write symmetry operators ***
      do 20 isym=1,nsym
        write(20,1100) ((IROT(i,j,isym),j=1,3),i=1,3),
     $                 (RTRS(i,isym),i=1,3)
20    continue
C     *** write sub-lattice translations ***
      write(20,1070) ((RSUB(i,isub),i=1,3),isub=1,nsub)
      CLOSE(20)
      return
      end
