C Here all necessary source files for MEND have been collected,
C to be compiled without makefile, in one command
C	f77 mendallessingle
C Additionally, this is a single precision version of MEND
C K. Burger, March 1998
C--------------------------------------------------------------------
C     CALCULATE FUNCTION CONSTRAINT,RFACT AND WRFACT.
C--------------------------------------------------------------------
C
      SUBROUTINE CALCON(ngsw,conf,cong,wrfact,rfact,connew,tnref,
     $     mref,nrefF,nrefG,FCAL,PROF,FOBS,SIGF,GCAL,GOBS,SIGG )
C
      IMPLICIT none
      integer ngsw,mref,nrefF,nrefG,iref
      real*4 conf,cong,wrfact,rfact,connew,tnref
      real*4 FCAL(2,mref),PROF(mref),FOBS(2,MREF),SIGF(MREF),
     $ GCAL(MREF),GOBS(mref),SIGG(MREF)
      real*4 bs1,bb1,bs2,bb2,er,ed2,eo2
CENT  real*4 ei
C
      CONF=0.0
      CONG=0.0
      BS1=0.0
      BB1=0.0
      BS2=0.0
      BB2=0.0
C
C*** CALCULATE F-TYPE CONSTRAINT FUNCTION. ***
C
      DO 10 iref=1,nrefF
         ER=FCAL(1,iref)*PROF(iref)-FOBS(1,iref)
CENT     EI=FCAL(2,iref)*PROF(iref)-FOBS(2,iref)
         ED2=ER*ER
CENT $       +EI*EI
         EO2=FOBS(1,iref)**2
CENT $       +FOBS(2,iref)**2
         CONF=CONF+ED2/SIGF(iref)
         BS1=BS1+ED2/SIGF(iref)
         BB1=BB1+EO2/SIGF(iref)
         BS2=BS2+sqrt(ED2)
         BB2=BB2+sqrt(EO2)
   10 CONTINUE
C
C     IF(NGSW.NE.0) GOTO 30
C
C*** CALCULATE G-TYPE CONSTRAINT FUNCTION. ***
C
      DO 20 iref=1,nrefG
         ED2=(GCAL(iref)-GOBS(iref))**2
         EO2=GOBS(iref)**2
         CONG=CONG+ED2/SIGG(iref)
         BS1=BS1+ED2/SIGG(iref)
         BB1=BB1+EO2/SIGG(iref)
         BS2=BS2+sqrt(ED2)
         BB2=BB2+sqrt(EO2)
   20 CONTINUE
C
C*** CALCULATE R-FACTOR AND COMBINED CONSTRAINT FUNCTION ***
C
C 30  
      WRFACT=sqrt(BS1/BB1)
      RFACT=BS2/BB2
      CONNEW=(CONF+CONG)/tnref
C
      RETURN
      END
C
C--------------------------------------------------------------------
C     CALCULATE FUNCTION ENTROPY AND LAGRANGEAN.
C--------------------------------------------------------------------
C
      SUBROUTINE CALFN(masym,nasym,entj,entsp,entsm,
     $   rtasym,RDENp,RDENm,RDEOp,RDEOm,RASYM,
     $   qfunc,lambda,connew)
C
      IMPLICIT  none
      integer*4 masym,nasym,ia
      real*4 RDENp(masym),RDENm(masym),RDEOp(masym),RDEOm(masym),
     $  RASYM(masym)
      real*4 entj,entsp,entsm,rtasym,qfunc,lambda,connew
     $ ,rj,rsp,rsm
C
      rj=0.0
      rsp=0.0
      rsm=0.0
      DO 10 ia=1,nasym
        rj=rj-(  RDENp(ia)*log(RDENp(ia)/RDEOp(ia))
     $         + RDENm(ia)*log(RDENm(ia)/RDEOm(ia)) ) /RASYM(ia)
        rsp=rsp- RDENp(ia)*log(RDENp(ia)) / RASYM(ia)
        rsm=rsm- RDENm(ia)*log(RDENm(ia)) / RASYM(ia)
   10 CONTINUE
      entsp=rsp*rtasym
      entsm=rsm*rtasym
      entj=rj*rtasym
      qfunc=entj-lambda*connew
C
      RETURN
      END
C     *************************************
C     *   DISPLAY RESULT OF CALCULATIONS  *
C     *************************************
C
      SUBROUTINE dspresul(ifile,
     $  connew,conf,cong,delta,rfact,wrfact,entsp,entsm,entj,qfunc,
     $  IHIST,FHIST,mhist,nhist,iptyp,ncycl,
     $  mref,nrefF,nrefG,FOBS,FCAL,SIGF,
     $  PROF,NGRP,GOBS,GCAL,SIGG,IDX)
C
      integer mref,nrefF,nrefG
C     *** variables connected with the structure factors given as input:
C     *** FOBS: unique reflections, GOBS: groups of non-unique refl.
C     *** SIGF, SIGG are the sigma^2 of |Fobs| and Gobs.
      real*4 FOBS(2,mref),FCAL(2,mref),SIGF(mref),GCAL(mref),
     $    PROF(mref),GOBS(mref),SIGG(mref)
      integer IDX(3,mref),NGRP(mref),i,j,iref,jref
      integer ifile,iptyp,ncycl
      real*4 connew,conf,cong,delta,rfact,wrfact,entsp,entsm,
     $  entj,qfunc
C
C     *** variables connected with lambda-history list:
      integer mhist,nhist,IHIST(MHIST)
      real*4 FHIST(3,MHIST),dev
C
 3030 FORMAT( /' CON=',F16.7,' CONF=',F16.7,' CONG=',F16.7
     $        /'DELT=',F16.7,'    R=',F16.7,'   WR=',F16.7)
 3040 FORMAT(  ' ent+=',F15.7,' ent-=',f15.7,' ents=',f15.7,
     $        /' entj=',F15.7,' lagr=',F15.7)
 3050 FORMAT(//' *********   FINAL RESULT OF MEED ANALYSIS   *******',
     $       '*************************')
 3065 FORMAT(//' *********   HISTORY OF CHANGING LAMBDA  ***********',
     $       '*************************'/' ')
 3070 FORMAT(' CYCLE=',I5,
     +       ', LAMBDA=',F10.7,' --> ',F10.7,', CON=',F15.3)
C
C *** Title of Fobs-list with preferred orientation ***
C
 3080 FORMAT(//' *********   LIST OF STRUCTURE FACTORS   ***********',
     $ '*************************'//'  H  K  L ',5X,'FOBS',18X,
     $ 'FCAL*P',16X,'FCAL','                  dev.')
C
C *** Title of Fobs-list without preferred orientation ***
C
 3081 FORMAT(//' *********   LIST OF STRUCTURE FACTORS   ***********',
     $ '*************************'//'  H  K  L ',5X,'FOBS',18X,
     $ 'FCAL','                 dev.')
C                  hkl    Fobs  Fcal*p  Fcal  dev
 3090 FORMAT(' ',3(I2,1X),6F11.4,1X,f7.2)	!Fobs with preferred orientation
C                  hkl    Fobs  Fcal  dev
 3091 FORMAT(' ',3(I2,1X),4F11.4,1X,f7.2)	!Fobs without p.o.
C
C *** Title of Gobs-list ***
C
 3100 FORMAT(/'  H  K  L ',5X,'GOBS',9X,'GCAL',11X,'FCAL',18x,'dev.')
C *** for Gobs-list: first line of a group
C                 hkl     Gcal     Gobs     Fcal      dev
 3110 FORMAT(' ',3(I2,1X),F11.4,2X,F11.4,4X,2F11.4,2X,f7.2)
C *** for Gobs-list: following lines
C                 hkl        Fcal
 3115 FORMAT(' ',3(I2,1X),28X,2F11.4)

C 3120 FORMAT(/' *********   END OF MEED ANALYSIS  DATE ',2A4,'  TI',
C     $       'ME ',2A4,'   ***********',3(/' '))
 3120 FORMAT(/' *********   END OF MEED ANALYSIS   ***********')
C
      WRITE(ifile,3050)
      WRITE(ifile,3030) connew,conf,cong,delta,rfact,wrfact
      WRITE(ifile,3040) entsp,entsm,entsp+entsm,entj,qfunc
      IF (nhist.NE.0) THEN
         WRITE(ifile,3065)
         WRITE(ifile,3070) (IHIST(J),(FHIST(K,J),K=1,3),J=1,nhist)
      END IF
      WRITE(ifile,'(a,i6)')' Number of cycles calculated:',ncycl
C
C     CALL DSPTIM(ifile,ITCYCL)
C
      if (iptyp.ge.0) then
        WRITE(ifile,3080)
      else
        write(ifile,3081)
      endif
      DO 80 iref=1,nrefF
         jh=IDX(1,iref)
         jk=IDX(2,iref)
         jl=IDX(3,iref)
         fcpr=FCAL(1,iref)*PROF(iref)
         fcpi=FCAL(2,iref)*PROF(iref)
	 dev=( sqrt( fcpr**2 + fcpi**2 ) - 
     $         sqrt( FOBS(1,iref)**2 + FOBS(2,iref)**2 )  
     $        )/sqrt(SIGF(iref))
	 if (iptyp.ge.0) then
C	   *** Fobs with preferred orientation ***
           WRITE(ifile,3090) jh,jk,jl,
     $       (FOBS(j,iref),j=1,2),fcpr,fcpi,
     +       (FCAL(j,iref),j=1,2), dev
	 else
C	   *** Fobs without p.o. ***
           WRITE(ifile,3091) JH,JK,JL,
     $       (FOBS(j,iref),j=1,2),
     $       (FCAL(j,iref),j=1,2), dev
	 endif  
   80 CONTINUE
      write(ifile,*) 
     $   'Relative deviation dev=(|Fcal|-|Fobs|)/sigma(|F|)'
      IF (nrefG.EQ.0) GO TO 270
      jref=iref-1
      WRITE(ifile,3100)
      DO 90 iref=1,nrefG
	 dev= ( GCAL(iref)-GOBS(iref) )/sqrt(SIGG(iref))
         DO 90 IGRP=1,NGRP(iref)
            jref=jref+1
            jh=IDX(1,jref)
            jk=IDX(2,jref)
            jl=IDX(3,jref)
            IF (igrp.EQ.1) THEN
               WRITE(ifile,3110)
     $         jh,jk,jl,GOBS(iref),GCAL(iref),
     $         (FCAL(j,jref),j=1,2), dev
            ELSE
               WRITE(ifile,3115) jh,jk,jl,(FCAL(j,jref),j=1,2)
            END IF
   90 continue
      write(ifile,*) 
     $   'Relative deviation dev=(Gcal-Gobs)/sigma(G)'
  270 WRITE(ifile,3120) 
      print *
      RETURN
      END
C--------------------------------------------------------------------
C     DISPLAY OR OUTPUT ELAPSED CPU TIME.
C--------------------------------------------------------------------
C
      SUBROUTINE DSPTIM(NN,ITCYCL)
C
C 1000 FORMAT(//' ELAPSED CPU TIME = ',I3,' MIN ',I2.2,' SEC,',
C     $       '  AFTER ',I5,' CYCLES CALCULATION.')
C
C*** CAUTION : THIS SUBROUTINE CAN BE ONLY USED BY FACOM. ***
C      CALL CLOCK(NSEC)
C      WRITE(NN,1000) NSEC/60,MOD(NSEC,60),ITCYCL
C
      RETURN
      END
C--------------------------------------------------------------------
C     Input new values for lambda and alpha
C     PRESERVE HISTORY OF CHANGES OF lambda.
C--------------------------------------------------------------------
C
      SUBROUTINE HISTRY(itcycl,delta,alpha,lambda,nhist,
     $                  mhist,FHIST,IHIST,conold)
C
      IMPLICIT none
      integer nhist,mhist
      integer IHIST(mhist),itcycl,i
      real*4 FHIST(3,mhist),delta,alpha,lambda,conold,wert
      logical CR,error
C
1000  FORMAT(a)
1001  FORMAT(a,' [default value=',g15.8,']')
3000  FORMAT(' !!! THE CONSTRAINT FUNCTION DIVERGES !!!')
C
10    IF (delta.GE.0.0) then
        WRITE(6,3000)
        WRITE(*,1001) 'Input a smaller value for lambda. ',lambda
      else
        WRITE(*,1001) 'Input a new value for lambda. ',lambda
      endif
      write(*,1000)
     $   '(hit the RETURN key, if you do not want to change it)'
      CALL abfrage(wert,i,CR,error)
      if (error) goto 10
      if (.not.CR) then
        if (wert.lt.0.) then
          print *,'wrong input'
          goto 10
        else
          nhist=nhist+1
	  if (nhist.gt.mhist) nhist=mhist
          FHIST(1,nhist)=lambda
          lambda=wert
          FHIST(2,nhist)=lambda
          FHIST(3,nhist)=conold
          IHIST(nhist)=itcycl
        endif
      else
	print *,'lambda unchanged'
      endif

20    WRITE(*,1001) 'Input a new final CON-value. ',alpha
      CALL abfrage(wert,i,CR,error)
      if (error) goto 20
      if (.not.CR) then
        if (wert.lt.0) then
          print *,'wrong input'
          goto 20
        else
          alpha=wert
        endif
      else
	print *,'CON-value unchanged'
      endif
C
      RETURN
      END
C--------------------------------------------------------------------
C     SOLVE EQUATION (10) IN REFERENCE.
C calculate derivatives dC/drho, and with them the new density
C new density of given pixel = old den * EXP(-lambda*(derivative))
C with derivate = sum dC/drho of all constraints: F- and G-type
C--------------------------------------------------------------------
C 
C*   IDX(1..3,1..nref) contains the hkl-indices of ALL reflections
C*   FOBS(1..2,1..nrefF) contains the A and B of F-constraints (F=A+iB)
C*   SIGF(1..nrefF) contains the sigmas(|F|) of the F-constraints
C*   GOBS(1..nrefG) contains the mean |F| of G-constraints
C*     SIGG(1..nrefG) contains the sigma of Gobs of group j
C*     NGRP(1..nrefG) contains the number of reflections in group j
C*     PMUL(1..nrefG+..) contains the multiplicity of reflections in groups
C*     PMULS(1..nrefG) contains the sum of the multiplicities of group j
C*   nrefF,nrefG contain the numbers of constraints: F, G
C*   nref=total number of reflections>=nrefF+nrefG
C*   FCAL(1..2,1..nref) contains the calculated A and B of ALL constraints
C*   GCAL(1..nrefG) contains the calculated |G| of the G-constraints
C
C*   RDEOp,RDEOm are the old density values
C*   RDENp,RDENm are the new density values
C
      SUBROUTINE MAXENT(ngsw,mref,nrefF,nrefG,masym,nasym,rtasym
     $  ,FOBS,FCAL,PROF,SIGF,NGRP,GOBS,GCAL,SIGG,tnref,lambda
     $  ,RMIC
CENT $  ,RMIS
     $  ,PMUL,PMULS,RDEOp,RDEOm,RDENp,RDENm,
     $   RHELP1,RHELP2,RHELP3,denmin,sumBp,sumBm,rtBp,rtBm)
C
      IMPLICIT none
      integer ngsw,mref,jref,iref,nrefF,nrefG,igrp
      integer*4 masym,nasym,ia
C     *** density arrays ***
      real*4 RDENp(masym),RDENm(masym),RDEOp(masym),RDEOm(masym)
     $   ,rtasym,rtBp,rtBm
C     *** structure factor lists ***
      real*4 FOBS(2,mref),FCAL(2,mref),SIGF(mref),PROF(mref),
     $         GOBS(mref),GCAL(mref),SIGG(mref)
      integer NGRP(mref)
      real*4 PMUL(mref),PMULS(mref)
C     *** total number of Fobs/Gobs given 
      real*4 tnref    
C     *** scattering length sums, positive and negative:
      real*4 sumBp, sumBm
C     *** cosine and sinus-tables ***
      real*4 RMIC(mref,masym)
CENT  real*4 RMIS(mref,masym)
C     *** auxilary arrays ***
      real*4 RHELP1(mref),RHELP2(mref),RHELP3(mref) 
      real*4 sum1,lambda,derf,derg,denmin,d
C
C     *** precalculations ***
C
C
C     *** for F-constraints ***
      do 1 iref=1,nrefF
        RHELP1(iref)= (FCAL(1,iref)*PROF(iref)-FOBS(1,iref))
     $	          /(SIGF(iref)*rtasym)
CENT    RHELP2(iref)= (FCAL(2,iref)*PROF(iref)-FOBS(2,iref))
CENT $            /(SIGF(iref)*rtasym)
1     continue
C
C     *** for G-constraints ***
      IF (ngsw.EQ.0) THEN
        jref=nrefF+1
        DO 3 iref=1,nrefG
          DO 2 igrp=1,NGRP(iref)
            RHELP1(jref)=PMUL(jref-nrefF)*FCAL(1,jref)*PROF(jref)
CENT        RHELP2(jref)=PMUL(jref-nrefF)*FCAL(2,jref)*PROF(jref)
            jref=jref+1
2         continue
          RHELP3(iref)= (GCAL(iref)-GOBS(iref))/
     $          (GCAL(iref)*SIGG(iref)*PMULS(iref)*rtasym)
3       continue
      ENDIF
C     *** end precalculations ***
C
C     *** now calculate derivatives for each point in asymmetric unit ***
C
      derf=0.0
      derg=0.0
      DO 10 ia=1,nasym
C        *** DERIVATIVE FOR F-TYPE CONSTRAINT ***
         derf=0.0
         DO 20 iref=1,nrefF
           derF=derF + RHELP1(iref)*RMIC(iref,ia)
CENT $               + RHELP2(iref)*RMIS(iref,ia)
   20    CONTINUE
         if (nrefF.gt.0) derF=derF/nrefF
C
C        *** DERIVATIVE FOR G-TYPE CONSTRAINT ***
         IF (ngsw.EQ.0) THEN
         derG=0.0
         jref=nrefF+1
         DO 40 iref=1,nrefG
           sum1=0.0
           DO 50 igrp=1,NGRP(iref)
             sum1=sum1 + RHELP1(jref)*RMIC(jref,ia)
CENT $                 + RHELP2(jref)*RMIS(jref,ia)
             jref=jref+1
   50      CONTINUE
           derG=derG+sum1*RHELP3(iref)
   40    CONTINUE
         if (nrefG.gt.0) derG=derG/nrefG
         END IF
C
C*** SOLVE EQ.(10) IN REFERENCE. ***
C
         RDENp(ia)=RDEOp(ia)*exp(-lambda*sumBp*(derF+derG))
         RDENm(ia)=RDEOm(ia)*exp(-lambda*sumBm*(derF+derG))
C
C        *** check, whether both the positive and the negative part
C        *** of the density part are large, and put the density where
C        *** it belongs: if the sum is negative, attach it to the negative
C        *** part and reset the positive density to its minimum value.

C        d=rtBp*RDENp(ia) + rtBm*RDENm(ia)	!real density sum

C        does not work!!!
         if (1.eq.0) then
         if (d.lt.0) then 
           if (rtBp.gt.0) RDENp(ia)=denmin/rtBp	!reset positive density
           if (rtBm.lt.0) RDENm(ia)=d/rtBm	!d and rtBm are negative
         else
           if (d.eq.0) then
              RDENp(ia)=denmin/rtBp		!reset both densities
              RDENm(ia)=denmin/rtBm
           else
C             *** d>0 
              if (rtBp.gt.0) RDENp(ia)=d/rtBp		!d and rtBp are positive
              if (rtBm.lt.0) RDENm(ia)=denmin/rtBm	!reset negative density
           endif
         endif
         endif
C
C        *** check underflow ***
         if (rtBp.gt.0) then
           if (RDENp(ia)*rtBp.lt.denmin) RDENp(ia)=denmin/rtBp 
         endif
         if (rtBm.lt.0) then
           if (RDENm(ia)*abs(rtBm).lt.denmin) 
     $         RDENm(ia)=denmin/abs(rtBm) 
         endif
C
   10 CONTINUE
C
      RETURN
      END
C--------------------------------------------------------------------
C     MAKE ASYMMETRIC UNIT CELL COORDINATE. ( PIXEL UNIT )
C     AND PHASE FACTOR TABLES
C--------------------------------------------------------------------
C
      SUBROUTINE MKASYM(isw,masym,nasym,mpix,NPIX,
     $  IROT,RTRS,RSUB,nsym,ncen,nsub,
     $  RDENp,RDENm,rtasym,RASYM,rdint,IASYM,
     $  RMIC,
CENT $  RMIS,
     $  IDX,mref,nref,IDE,pi)
C
C     *** ncen = 0/1 for no/a center of inversion present in the cell
C     *** nsym = number of symetry operators (1<=nsym<=48)
C     *** nsub = number of sub-translations in the cell because of 
C     ***        a non-primitive Bravais lattice: I,A,B,C,F,R (1<=nsub<=4)
C     *** IROT() = array of all symmetry operators' rotation matrices
C     *** RTRS() = array of corresponding translation vectors
C     *** RSUB() = transl. vectors belonging to cell-sub-translations
C
      IMPLICIT none
      integer*4 nasym,masym,ia
      integer isw,mpix,nsym,ncen,nsub,mref,nref
      real*4 rtasym,rdint,pi,twopi,phs
C     *** density array ***
      real*4 RDENp(masym),RDENm(masym),RASYM(masym)
C     *** pixels along a,b,c axis; ia,ib,ic of pixels in asymm. unit ***
      integer NPIX(3),IASYM(3,masym)
C     *** symmetry operators ***
      integer IROT(3,3,48)
      real*4 RTRS(3,48),RSUB(3,4)
C     *** (hkl) of all given reflections ***
      integer IDX(3,mref)
C     *** cosine- and sine-tables ***
      real*4 RMIC(mref,masym)
CENT $      ,RMIS(mref,masym)
C     *** auxilary array ***
      integer IDE(0:mpix,0:mpix,0:mpix)
      integer kx,ky,kz,ic,it,is,nx,ny,nz,iref
      real*4 x,y,z,rx,ry,rz
      twopi=2*pi
C
C*** MAKE ASYMMETRIC UNIT COODINATE ***
C
      print *,'Calculating asymmetric unit pixels'
      IF (ISW.EQ.0) THEN
      nasym=0
      DO 10 KZ=0,NPIX(3)-1
      DO 10 KY=0,NPIX(2)-1
      DO 10 KX=0,NPIX(1)-1
      IF (IDE(KX,KY,KZ).GT.-1) THEN
	x=kx/FLOAT(npix(1))
	y=ky/FLOAT(npix(2))
	z=kz/FLOAT(npix(3))
        DO 20 IC=1,NCEN+1
        DO 20 IT=1,NSUB
        DO 20 IS=1,NSYM
        rx=IROT(1,1,IS)*x+IROT(1,2,IS)*y+IROT(1,3,IS)*z+RTRS(1,IS)
        ry=IROT(2,1,IS)*x+IROT(2,2,IS)*y+IROT(2,3,IS)*z+RTRS(2,IS)
        rz=IROT(3,1,IS)*x+IROT(3,2,IS)*y+IROT(3,3,IS)*z+RTRS(3,IS)
        IF (IC.EQ.2) THEN
          NX=NINT( amod(2-rx+RSUB(1,IT),1.0)*NPIX(1) )
          NY=NINT( amod(2-ry+RSUB(2,IT),1.0)*NPIX(2) )
          NZ=NINT( amod(2-rz+RSUB(3,IT),1.0)*NPIX(3) )
	ELSE
          NX=NINT( amod(2+rx+RSUB(1,IT),1.0)*NPIX(1) )
          NY=NINT( amod(2+ry+RSUB(2,IT),1.0)*NPIX(2) )
          NZ=NINT( amod(2+rz+RSUB(3,IT),1.0)*NPIX(3) )
        END IF
        IF (KX.NE.NX.OR.KY.NE.NY.OR.KZ.NE.NZ) IDE(NX,NY,NZ)=-1
   20   CONTINUE
        nasym=nasym+1
        IF (nasym.GT.MASYM) CALL PROEND(
     $   'DIMENSION OVER FOR MKASYM - TOO MANY POINTS IN ASYM. UNIT')
C       *** RDEN is normalized to unit value for both parts, + and -
        RDENp(nasym)=rdint
        RDENm(nasym)=rdint
        IASYM(1,nasym)=KX
        IASYM(2,nasym)=KY
        IASYM(3,nasym)=KZ
      END IF
   10 CONTINUE
      END IF
C
C*** MAKE PHASE FACTOR TABLES ***
C
      print *,'Calculating phase-factor tables'
      RTASYM=float(NSUB*NSYM*(NCEN+1))
      DO 30 KX=0,NPIX(1)-1
      DO 30 KY=0,NPIX(2)-1
      DO 30 KZ=0,NPIX(3)-1
         IDE(KX,KY,KZ)=0
   30 CONTINUE
      DO 40 IC=1,NCEN+1
      DO 40 IT=1,NSUB
      DO 40 IS=1,NSYM
      DO 40 IA=1,nasym
	x=iasym(1,ia)/float(npix(1))
	y=iasym(2,ia)/float(npix(2))
	z=iasym(3,ia)/float(npix(3))
        rx=IROT(1,1,IS)*x+IROT(1,2,IS)*y+IROT(1,3,IS)*z+RTRS(1,IS)
        ry=IROT(2,1,IS)*x+IROT(2,2,IS)*y+IROT(2,3,IS)*z+RTRS(2,IS)
        rz=IROT(3,1,IS)*x+IROT(3,2,IS)*y+IROT(3,3,IS)*z+RTRS(3,IS)
        IF (IC.EQ.2) THEN
          rx= amod(2-rx+RSUB(1,IT),1.0)
          ry= amod(2-ry+RSUB(2,IT),1.0)
          rz= amod(2-rz+RSUB(3,IT),1.0)
	ELSE
          rx= amod(2+rx+RSUB(1,IT),1.0)
          ry= amod(2+ry+RSUB(2,IT),1.0)
          rz= amod(2+rz+RSUB(3,IT),1.0)
        END IF
	NX=NINT( rx*npix(1) )
	NY=NINT( ry*npix(2) )
	NZ=NINT( rz*npix(3) )
        IDE(NX,NY,NZ)=IDE(NX,NY,NZ)+1
        DO 50 iref=1,NREF
          phs=twopi*(rx*IDX(1,iref)+ry*IDX(2,iref)+rz*IDX(3,iref))  
          RMIC(iref,IA)=RMIC(iref,IA)+cos(phs)
CENT      RMIS(iref,IA)=RMIS(iref,IA)+sin(phs)
   50   CONTINUE
   40 CONTINUE
      DO 60 IA=1,nasym
         RASYM(IA)=float(IDE(IASYM(1,IA),IASYM(2,IA),IASYM(3,IA)))
   60 CONTINUE
      print *,'... finished'
C
      RETURN
      END
C--------------------------------------------------------------------
C     NORMALIZE UNIT CELL DENSITY to sum = 1.
C--------------------------------------------------------------------
C
      SUBROUTINE NORMAL(masym,nasym,RDENp,RDENm,
     $ RASYM,rtasym)
C
      IMPLICIT none
      integer*4 masym,nasym,ia
      real*4 RDENp(masym),RDENm(masym),RASYM(masym),
     $  sumdp,sumdm,ratep,ratem,rtasym
C
      sumdp=0.0
      sumdm=0.0
      DO 10 ia=1,nasym
         sumdp=sumdp + RDENp(ia)/RASYM(ia)
         sumdm=sumdm + RDENm(ia)/RASYM(ia)
   10 CONTINUE
C     normalize to density sum=1
      ratep=1./(rtasym*sumdp)
      ratem=1./(rtasym*sumdm)
      DO 30 ia=1,nasym
        RDENp(ia)=RDENp(ia)*ratep
        RDENm(ia)=RDENm(ia)*ratem
   30 CONTINUE
C
      RETURN
      END
C--------------------------------------------------------------------
C     MAKE PREFERED ORIENTATION CORRECTION FACTOR
C     ON EACH REFLECTION.
C--------------------------------------------------------------------
C
      SUBROUTINE POCOR(iptyp,pop,PROF,nref,mref,IDX,
     $	               as,bs,cs,ga,gb,gg,rh,rk,rl,pi)
      IMPLICIT none
      integer iptyp,mref,nref,IDX(3,mref),iref,jh,jk,jl
      real*4  PROF(mref),pop,as,bs,cs,ga,gb,gg,rh,rk,rl,pi,
     $  qh,qk,ql,s1,s2,s3,s4,s5,s6,qr,qq
C
      do 10 iref=1,nref
      IF (iptyp.lt.0) THEN
         PROF(iref)=1.0
      ELSE
         JH=IDX(1,iref)
         JK=IDX(2,iref)
         JL=IDX(3,iref)
         QH=float(JH)*AS
         QK=float(JK)*BS
         QL=float(JL)*CS
         S1=QH*QH+QK*QK+QL*QL
         S2=RH*RH+RK*RK+RL*RL
         S3=RH*QH+RK*QK+RL*QL
         S4=0.5*RH*(QK*GG+QL*GB)
         S5=0.5*RK*(QH*GG+QL*GA)
         S6=0.5*RL*(QH*GB+QK*GA)
         QR=(S3+S4+S5+S6)/SQRT(S1*S2)
C        QQ=cos(amod(QR,2*pi))
         QQ=cos(QR)
C*** CASE : NEEDLE LIKE ORIENTATION ***
         IF(iptyp.NE.0) QQ=PI/2.0-QQ
C*** CAUTION : PROF=SQRT( P(PHI) ) ***
         PROF(iref)=exp(-0.5*POP*QQ*QQ)
      END IF
10    continue
C
      RETURN
      END
C
C--------------------------------------------------------------------
C     CALCULATE CONSTANTS FOR MAXENT PROCESS.
C--------------------------------------------------------------------
C
      SUBROUTINE PRECAL(jph,jpk,jpl,pi,rad,ca,cb,cg,sa,sb,sg,
     $   da,db,dg,dv,sv,as,bs,cs,ga,gb,gg,rh,rk,rl,av,
     $   rdint,sumBp,sumBm,rtBp,rtBm,CELL,NPIX)
C
      IMPLICIT none
      integer NPIX(3),jph,jpk,jpl
      real*4 CELL(6),pi,rad,ca,cb,cg,sa,sb,sg,
     $   da,db,dg,dv,sv,as,bs,cs,ga,gb,gg,rh,rk,rl,av,
     $   rdint,sumBp,sumBm,rtBp,rtBm
C
      PI=2*acos(0.0)
      RAD=PI/180.0
C
C*** CONSTANTS FOR RECIPROCAL SPACE ***
C
C     *** ca, cb, cg= cos (alpha, beta, gamma)
      CA=cos(RAD*CELL(4))
      CB=cos(RAD*CELL(5))
      CG=cos(RAD*CELL(6))
C     *** sa, sb, sg= sin (alpha, beta, gamma)
      SA=sin(RAD*CELL(4))
      SB=sin(RAD*CELL(5))
      SG=sin(RAD*CELL(6))
      DA=CB*CG-CA
      DB=CG*CA-CB
      DG=CA*CB-CG
      DV=1.0-CA*CA-CB*CB-CG*CG+2.0*CA*CB*CG
C     *** sv = V_cell / (a b c)
      SV=sqrt(DV)
C     *** as, bs, cs = astar, bstar, cstar in reciprocal space
      AS=SA/(CELL(1)*SV)
      BS=SB/(CELL(2)*SV)
      CS=SG/(CELL(3)*SV)
C     *** ga, gb, gg = 2*cos(alphas, betas, gammas) in reciprocal space
      GA=2.0*DA/(SB*SG)
      GB=2.0*DB/(SG*SA)
      GG=2.0*DG/(SA*SB)
      RH=JPH*AS
      RK=JPK*BS
      RL=JPL*CS
C
C*** CONSTANTS FOR DENSITY DATA ***
C
C     *** av= cell volume
      AV=CELL(1)*CELL(2)*CELL(3)*SV
C     *** rdint= initial density of flat distribution
      RDINT=1/float(NPIX(1)*NPIX(2)*NPIX(3)) 
      rtBp=sumBp * float(NPIX(1)*NPIX(2)*NPIX(3)) / AV
      rtBm=sumBm * float(NPIX(1)*NPIX(2)*NPIX(3)) / AV
C
      RETURN
      END
C
C--------------------------------------------------------------------
C     TERMINATE PROGRAM BECAUSE ERROR OCCURED.
C--------------------------------------------------------------------
C
      SUBROUTINE PROEND(MESS)
C
      CHARACTER*(*) MESS
C
 3000 FORMAT(///' !!! ERROR !!! : ',A)
C
      WRITE(6,3000) MESS
      WRITE(30,3000) MESS
      CLOSE(30)
C
      STOP
      END
C--------------------------------------------------------------------
C     READ SPACE GROUP DATA BASE AND MAKE SYMMETRY OPERATIONS.
C--------------------------------------------------------------------
C
      SUBROUTINE RDSPG(nsg,nset,aspg,nsym,ncen,nsub,
     $  IROT,RTRS,RSUB,CELL)
C
C     *** nsg = number of space group (1<=nsg<=230)
C     *** nset = number of s.g. setting (1<=nset<=2)
C     *** ncen = 0/1 for no/a center of inversion present in the cell
C     *** nsym = number of symetry operators (1<=nsym<=48)
C     *** nsub = number of sub-translations in the cell because of 
C     *** IROT() = array of all symmetry operators' rotation matrices
C     *** RTRS() = array of corresponding translation vectors
C     *** RSUB() = transl. vectors belonging to cell-sub-translations
C     *** nsg: Number of space group, nset: its setting (1 or 2)
C     *** aspg: Name of space group
C     *** nsym: Number of symmetry operators 
C     *** ncen: 0/1 for non-existence/existence of a center of inversion
C     *** nsub: Number of cell sub-translatins (1..4)
C
      IMPLICIT none
      integer IROT(3,3,48),nsg,nset,nsym,ncen,nsub
      real*4 RTRS(3,48),RSUB(3,4),CELL(6)
      CHARACTER ASPG*10,COORD(48)*20,CH*1,XYZ(3)*1,SYM(3)*10,
     $          CD*20,SYMM*10,filsym*40
      integer ixx,isym,i,j,i1,i2,isg,iset,idummi,nn,
     4        it,itr1,itr2
      logical yesno,yesno2
      DATA (XYZ(J),J=1,3)/'X','Y','Z'/
C
 1000 FORMAT(5I3,3X,A10)
 1010 FORMAT(14I2)
 1020 FORMAT(A20)
 1030 FORMAT()
C
C*** READ DATA BASE ***
C
C*** CAUTION : you must replace the file-name by your own one ***
      INQUIRE(FILE='SPGRA.DAT',EXIST=yesno)
      if (yesno) then
        filsym='SPGRA.DAT'
      else
        INQUIRE(FILE='/mnt/usr/bin/SPGRA.DAT',EXIST=yesno2) 
        if (yesno2) then
          filsym='/mnt/usr/bin/SPGRA.DAT'
        else
          CALL PROEND(
     $    'File SPGRA.DAT with symmetry information not found.')
        endif
      endif
      OPEN(40,FILE=filsym,FORM='FORMATTED',STATUS='OLD',
     $     ACCESS='SEQUENTIAL',ERR=999)
      print *
      print *,'Symmetry information will be read from file ',filsym
      GOTO 10
C     ----------------
C     *** error ***
999   print *,'File ',filsym
      print *,'was found but could not be opened! '
      CALL PROEND(
     $  'File SPGRA.DAT with symmetry information unreadable.')
C
C     ----------------
   10 READ(40,1000,END=20) ISG,ISET,idummi,NCEN,NSYM,ASPG
      IF (NSG.EQ.ISG.AND.NSET.EQ.ISET) THEN
         READ(40,1010) (idummi,I=1,6),NN,(idummi,I=8,14)
         READ(40,1020) (COORD(I),I=1,NSYM)
         GO TO 25
      ELSE
         DO 15 idummi=1,NSYM+1
            READ(40,1030)
   15    CONTINUE
      END IF
      GO TO 10
   20 CALL PROEND('CAN NOT FIND YOUR SPACE GROUP SELECTION.')
C
C*** CONVERT STRING INTO ROT MATRIX AND TRS VECTOR. ***
C
   25 DO 30 isym=1,NSYM
C        *** loop over all symmetry operators ***
         cd=COORD(isym)
C        *** find position of the two kommas ','
         I1=INDEX(cd,',')
         DO 40 j=i1+2,19
            READ(CD(j:j),'(A1)') ch
            IF (ch.EQ.',') THEN
               i2=j
               GO TO 50
            END IF
   40    CONTINUE
   50    SYM(1)=CD(1:i1-1)
         SYM(2)=CD(i1+1:i2-1)
         SYM(3)=CD(i2+1:20)
         DO 80 i=1,3
C           *** loop over three SYM()-strings given for one operator
C           *** for the x,y,z-row of the matrix and transl.-vector
            symm=SYM(i)
            RTRS(i,isym)=0
            DO 60 j=1,3
               IROT(i,j,isym)=0
   60       CONTINUE
C           *** extract rotation matrix
            DO 70 j=1,3
c              *** loop over three possible letters x,y,z ***
               ixx=INDEX(symm,XYZ(j))
               IF (ixx.GT.0) THEN
                  IF (ixx.EQ.1) THEN
                     IROT(i,j,isym)=1
                  ELSE
                     IF (symm(ixx-1:ixx-1).EQ.'+') THEN
                        IROT(i,j,isym)=1
                     ELSE
                        IROT(i,j,isym)=-1
                     END IF
                  END IF
               END IF
   70       CONTINUE
C           *** extract translation vector
            it=INDEX(symm,'/')
            IF (it.GT.0) THEN
               READ(symm(it-1:it-1),'(I1)') itr1
               READ(symm(it+1:it+1),'(I1)') itr2
               IF (it.NE.2) then
                 if (symm(it-2:it-2).EQ.'-') itr1=-itr1
               endif
               IF (itr2.NE.0) RTRS(I,isym)=itr1/(1.0*itr2)
            END IF
   80    CONTINUE
   30 CONTINUE
C
C*** MAKE SUB-LATTICE TRS VECTORS. ***
C
      NSUB=1
      IF (NN.EQ.7) THEN
C*** F LATTICE ***
         RSUB(2,2)=0.5
         RSUB(3,2)=0.5
         RSUB(1,3)=0.5
         RSUB(3,3)=0.5
         RSUB(1,4)=0.5
         RSUB(2,4)=0.5
         NSUB=4
      ELSE IF (NN.EQ.4) THEN
C*** A LATTICE ***
         RSUB(2,2)=0.5
         RSUB(3,2)=0.5
         NSUB=2
      ELSE IF (NN.EQ.5) THEN
C*** B LATTICE ***
         RSUB(1,2)=0.5
         RSUB(3,2)=0.5
         NSUB=2
      ELSE IF (NN.EQ.6) THEN
C*** C LATTICE ***
         RSUB(2,2)=0.5
         RSUB(1,2)=0.5
         NSUB=2
      ELSE IF (NN.EQ.13) THEN
C*** I LATTICE ***
         RSUB(1,2)=0.5
         RSUB(2,2)=0.5
         RSUB(3,2)=0.5
         NSUB=2
      ELSE IF (NN.EQ.14) THEN
C*** RHOMBO HEDRALLY CENTERED ( OBVERSE SETTING ) ***
         RSUB(1,2)=2.0/3
         RSUB(2,2)=1.0/3
         RSUB(3,2)=1.0/3
         RSUB(1,3)=1.0/3
         RSUB(2,3)=2.0/3
         RSUB(3,3)=2.0/3
         NSUB=3
      ELSE IF (NN.EQ.15) THEN
C*** RHOMBO HEDRALLY CENTERED ( REVERSE SETTING ) ***
         RSUB(1,2)=1.0/3
         RSUB(2,2)=2.0/3
         RSUB(3,2)=1.0/3
         RSUB(1,3)=2.0/3
         RSUB(2,3)=1.0/3
         RSUB(3,3)=2.0/3
         NSUB=3
      END IF
C
C     *** display of symmetry info ***
C     CALL dspsym(nsg,nset,aspg,nsym,ncen,nsub,
C    $  IROT,RTRS,RSUB,CELL)
C
      RETURN
      END
      SUBROUTINE READDEN(filden,masym,nasym,IASYM,RDENp,RDENm,
     $ rtBp,rtBm)
      IMPLICIT none
      integer*4 masym,nasym,ia
      real*4 RDENp(masym),RDENm(masym),r,rtBp,rtBm
      integer IASYM(3,masym),i
      character*50 filden
C
      OPEN(20,FILE=FILDEN,FORM='FORMATTED',
     +     STATUS='OLD', ACCESS='SEQUENTIAL')
1080  format()
1040  format(i7)
1090  format(3(I4,1X),G21.6,2(1x,G21.6))
      READ(20,1080)
      READ(20,1040) nasym
      if (nasym.GT.masym) then
	 print *,'maximal number of pixels in asymmetric unit is'
     $     ,masym
	 print *,'number of pixels in density file is',nasym
         CALL PROEND(
     $   'DIMENSION OVER FOR RDEN - TOO MANY POINTS IN ASYM. UNIT')
      endiF
C     READ(20,1090,END=40) ((IASYM(I,ia),I=1,3),RDEN(ia),ia=1,nasym)
      do ia=1,nasym
        READ(20,*   ,END=40) 
     $  (IASYM(I,ia),I=1,3),r, RDENp(ia), RDENm(ia)
        RDENp(ia)=RDENp(ia)/rtBp	!do normalization
        RDENm(ia)=RDENm(ia)/rtBm	!now RDENm is positive
      end do
   40 CLOSE(20)
      return
      end
C*** READ MEED DATA AND MAKE SOME CONSTANTS. ***
C
C* - The list of F-constraints: h k l A B sigma(|F|) (phased reflections)
C* - The list of G-constraints: hkl-list + 1 Gobs and s(Gobs) (groups of refl.)
C*   IDX(1..3,1..nref) contains the hkl-indices of ALL reflections
C*   FOBS(1..2,1..nrefF) contains the A and B of F-constraints
C*   GOBS(mref) contains the mean |F| of G-constraints: GOBS(1..nrefG)
C*     NGRP(1..nrefG) contains the number of reflections in group j
C*     SIGG(1..nrefG) contains the sigma of Gobs of group j
C*     PMUL(1..nrefG+..) contains the multiplicity of reflections in groups
C*     PMULS(1..nrefG) contains the sum of the multiplicities of group j
C*   nrefF,nrefG contain the numbers of constraints: F, G
C*   nref=total number of reflections
C*   sumBp,sumBm are the scattering density sum of positive/negative density
C
      SUBROUTINE READMEM(filmem,title,CELL,pop,iptyp,jph,jpk,jpl,
     $  nsg,nset,NPIX,mpix,sumBp,sumBm,lambda,mref,nref,nrefF,nrefG,
     $  IDX,FOBS,SIGF,GOBS,SIGG,NGRP,PMUL,PMULS,ierr,igsw)
C
      IMPLICIT none
      integer iptyp,jph,jpk,jpl,nsg,nset,mpix,mref,nref,nrefF,nrefG,
     $     ierr,igsw,i,j,k,iref,igrp,mul
      real*4 CELL(6),FOBS(2,mref),SIGF(mref),GOBS(mref),
     $     SIGG(mref),PMUL(mref),PMULS(mref),lambda,pop,sumBp,sumBm
      integer NPIX(3),IDX(3,mref),NGRP(mref)
      character filmem*50, title*200
 1000 FORMAT(A)
 1015 FORMAT(F15.7,4I5)
C
      OPEN(10,FILE=FILMEM,FORM='FORMATTED',STATUS='OLD',
     $     ACCESS='SEQUENTIAL',ERR=201)
      ierr=0
      goto 202
C     *** error ***
201     print *,'file not found:',filmem
        ierr=1
        CLOSE(10)
        return
C
202   READ(10,1000) title
      READ(10,*) (CELL(I),I=1,6)
      READ(10,*) pop,iptyp,jph,jpk,jpl
      READ(10,*) nsg,nset,(NPIX(I),I=1,3)
      IF (NPIX(1)-1.GT.mpix.OR.NPIX(2)-1.GT.mpix.OR.
     $   NPIX(3)-1.GT.mpix) 
     $   CALL PROEND('DIMENSION OVER FOR IDE - TOO MANY PIXELS.')
      READ(10,*) sumBp,sumBm,lambda
      READ(10,*) nrefF
      IF (nrefF.GT.mref)  then
	 print *,'Maximal number of reflections:',mref
	 print *,'Given number                 :',nrefF
	 CALL PROEND('Too many Fobs given.')
      ENDIF
      DO 10 nref=1,nrefF
         READ(10,*)
     $   (IDX(I,nref),I=1,3),(FOBS(I,nref),I=1,2),SIGF(nref)
         SIGF(nref)=SIGF(nref)**2
   10 CONTINUE
      nref=nref-1
      write(*,*) nref, ' reflections Fobs found'
      if (igsw.eq.1) then
         nrefG=0
         GOTO 30
      endif
C     READ(10,1040,END=30) nrefG
      nrefG=0
      READ(10,*,END=30) nrefG
      IF (nrefG.eq.0) then
	 write(*,*) 'No Gobs found!'
	 igsw=1
	 GO TO 30
      elseif (nrefG.gt.mref) then
	 print *,'Maximal number of groups of reflections:',mref
	 print *,'Given number                           :',nrefG
	 CALL PROEND('Too many Gobs given.')
      ENDIF
      write(*,*) nrefG, ' groups of reflections Gobs'
      DO 20 iref=1,nrefG
C        READ(10,1040) NGRP(iref)
         READ(10,*) NGRP(iref)
         PMULS(iref)=0.0
         DO 25 igrp=1,NGRP(iref)
            nref=nref+1
            IF (nref.gt.mref) CALL PROEND(
     $        'DIMENSION OVER FOR FCAL - TOO MANY REFLECTIONS')
            IF (igrp.EQ.1) THEN
C              READ(10,1060)
               READ(10,*)
     $         (IDX(i,nref),i=1,3),GOBS(iref),SIGG(iref),mul
                 SIGG(iref)=SIGG(iref)**2
            ELSE
C              READ(10,1065) (IDX(i,nref),i=1,3),mul
               READ(10,*) (IDX(i,nref),i=1,3),mul
            END IF
	    if (mul.eq.0) then
              print *,(IDX(i,nref),i=1,3),mul
              call proend(
     $         'Error in input: Multiplicity of Gobs is zero')
            endif
            PMUL(nref-nrefF)=float(mul)
            PMULS(iref)=PMULS(iref)+float(mul)
   25    CONTINUE
   20 CONTINUE
   30 CLOSE(10)
      if (nrefG.eq.0) igsw=1
C
      return
      end
C--------------------------------------------------------------------
C     RENEW DENSITY RDEN INTO RDEO
C--------------------------------------------------------------------
C
      SUBROUTINE RENEW(masym,nasym,RDEOp,RDEOm,RDENp,RDENm)
C
      implicit none
      integer*4 masym,nasym,ia
      real*4 RDEOp(masym),RDEOm(masym),RDENp(masym),RDENm(masym)
C
      DO 10 ia=1,nasym
         RDEOp(ia)=RDENp(ia)
         RDEOm(ia)=RDENm(ia)
   10 CONTINUE
C
      RETURN
      END
C
C     save density of RDEN() array, together with symmetry information 
C     sum rho+ + rho- is saved, i.e. the total scattering density
C     of the positive and the negative density.
C  
      SUBROUTINE SAVEDEN(filden,
     $   masym,nasym,title,IASYM,RDENp,RDENm,CELL,NPIX
     $   ,nsym,ncen,nsub,IROT,RTRS,RSUB,rtBp,rtBm)
      IMPLICIT none
      integer*4 masym,nasym,ia
      real*4 RDENp(masym),RDENm(masym),CELL(6),RTRS(3,48),RSUB(3,4)
     $  ,rtBp,rtBm
      integer IASYM(3,masym),NPIX(3),IROT(3,3,48)
      integer nsym,ncen,nsub,i,j,isym,isub
      character title*200,filden*50
C
      OPEN(20,FILE=FILDEN,FORM='FORMATTED',
     $     STATUS='UNKNOWN', ACCESS='SEQUENTIAL')
1010  format(6F10.5)
1020  format(6i5)
1040  format(i7)
1070  format(f7.5,1x,f7.5,1x,f7.5)
1080  format(a,a,a)
C***  fuer VAX: 1080  format(a80)
1090  format(3(I4,1X),G21.6,2(1x,G21.6))
C   1100  format(12i5)       ! old symmetry operator format
1100  format(3(3i4,2x),2x,3(1x,f7.5)) 
      write(20,1080) title(1:80), title(81:160), title(161:200)
      write(20,1040) nasym
C
C     *** write density sum of asymmetric unit ***
      do 10 ia=1,nasym
        write(20,1090) (IASYM(i,ia),i=1,3),
     $    sngl( rtBp*RDENp(ia)+rtBm*RDENm(ia) ), 
     $    sngl(rtBp*RDENp(ia)), sngl(rtBm*RDENm(ia))
  10  continue
C
C     *** write cell constants ***
      write(20,1010) (CELL(i),i=1,6)
C
C     *** write pixel and symmetry information ***
      write(20,1020) (NPIX(i),i=1,3),nsym,ncen,nsub
C     *** write symmetry operators ***
      do 20 isym=1,nsym
        write(20,1100) ((IROT(i,j,isym),j=1,3),i=1,3),
     $                 (RTRS(i,isym),i=1,3)
20    continue
C     *** write sub-lattice translations ***
      write(20,1070) ((RSUB(i,isub),i=1,3),isub=1,nsub)
      CLOSE(20)
      return
      end
C--------------------------------------------------------------------
C     CALCULATE STRUCTURE FACTORS ( F-TYPE ) from asym. unit density
C--------------------------------------------------------------------
C
      SUBROUTINE STRCTF(masym,nasym,RDENp,RDENm
     $                  ,RMIC
CENT $                  ,RMIS
     $                  ,RASYM,mref,nref,FCAL,sumBp,sumBm)
C
      implicit none
      integer*4 masym,nasym,ia
      integer mref,nref,iref
      real*4 RDENp(masym),RDENm(masym),RASYM(masym),
     $       FCAL(2,mref)
     $       ,RMIC(mref,masym) 
CENT $       ,RMIS(mref,masym)
      real*4 frp,frm,fip,fim,sumBp,sumBm
C
      DO 210 iref=1,nref
         frp=0.0
CENT     fip=0.0
         frm=0.0
CENT     fim=0.0
         DO 220 ia=1,nasym
            frp=frp + RDENp(ia)*RMIC(iref,ia)/RASYM(ia)
CENT        fip=fip + RDENp(ia)*RMIS(iref,ia)/RASYM(ia)
            frm=frm + RDENm(ia)*RMIC(iref,ia)/RASYM(ia)
CENT        fim=fim + RDENm(ia)*RMIS(iref,ia)/RASYM(ia)
  220    CONTINUE
         FCAL(1,iref)=frp*sumBp + frm*sumBm
CENT     FCAL(2,iref)=fip*sumBp + fim*sumBm
  210 CONTINUE
C
      RETURN
      END
C
C--------------------------------------------------------------------
C     CALCULATE STRUCTURE FACTORS. ( TYPE-G ) from F_calc
C--------------------------------------------------------------------
C
      SUBROUTINE STRCTG( mref,nrefF,nrefG,FCAL,GCAL,
     $                   PROF,NGRP,PMUL,PMULS)
C
      IMPLICIT none
      integer mref,nrefF,nrefG,NGRP(mref),jref,iref,igrp
      real*4  FCAL(2,mref),GCAl(mref),PROF(mref)
     $ ,PMUL(mref),PMULS(mref),gg
C
      jref=nrefF+1
      DO 30 iref=1,nrefG
         GG=0.0
         DO 35 IGRP=1,NGRP(iref)
            GG=GG+PMUL(jref-nrefF)*(
     $      (FCAL(1,jref)*PROF(jref))**2
CENT $      +(FCAL(2,jref)*PROF(jref))**2
     $      )
            jref=jref+1
   35    CONTINUE
         GCAL(iref)=sqrt(GG/PMULS(iref))
   30 CONTINUE
C
      RETURN
      END
C     display symmetry operators
C
      SUBROUTINE dspsym(nsg,nset,aspg,nsym,ncen,nsub,
     $  IROT,RTRS,RSUB,CELL)
      IMPLICIT none
      real*4 RTRS(3,48),RSUB(3,4),CELL(6)
      integer IROT(3,3,48)
      integer nsg,nset,nsym,ncen,nsub,i,j,isym
      character aspg*10
C
      print *,'DISPLAY OF SYMMETRY INFORMATION'
      print *,'==============================='
      print *,'Spacegroup ',aspg
      write(*,'(a,i4,a,i2)') ' Number',nsg,' setting',nset
      write(*,'(a,i4)') ' Number of symm. operators given:',nsym
      write(*,'(a,i2)') ' Number of sub-translations:',nsub
      if (ncen.eq.0) print *,'No center of inversion present'
      if (ncen.eq.1) print *,'Center of inversion present'
      print *,'Cell-parameters a,b,c,alpha,beta,gamma:'
      write(*,'(6(f10.5,1x))') (CELL(i),i=1,6)
      print *,'IROT(3,3,nsym), RTRS(3,nsym):'
      write(*,'(3(3i4,2x),2x,3f5.3)') 
     $  (((IROT(i,j,isym),j=1,3),i=1,3),
     $  (RTRS(i,isym),i=1,3), isym=1,nsym)
      print  *,'RSUB(3,nsym):'
      write(*,'(3f5.3)') ((RSUB(i,isym),i=1,3),isym=1,nsub)
      print *,'Enter <RETURN> to continue'
      read(*,'(BN,i1)') i
C
      RETURN
      END
C****************************************************
 	SUBROUTINE ABFRAGE(WERT,IWERT,CR,ERROR)
C
        IMPLICIT none
        real*4 wert
        integer iwert,i
	CHARACTER*20 ZAHL
	LOGICAL CR,ERROR
C
	ERROR=.FALSE.
	CR=.FALSE.
	WERT=0.0
	IWERT=0
	ZAHL='                    '
C
	READ(*,'(A)') ZAHL
C
	IF (ZAHL(1:3).EQ.'   ') THEN
	  CR=.TRUE.
	  GOTO 9
	END IF
	CR=.FALSE.
C
	DO 5 I=1,20
	   IF(ZAHL(I:I).EQ.'.') GOTO 8
	   IF(ZAHL(I:I).EQ.' ') THEN
               ZAHL (I:I)='.'
	       GOTO 8
	   ENDIF
5	CONTINUE
C
8	READ(ZAHL,'(F12.0)',ERR=81) WERT
	ERROR=.FALSE.
	IWERT=NINT(WERT)
	GOTO 9
C
81	ERROR=.TRUE.
C
9	CONTINUE
	RETURN
	END
C========================================================================
C
C     mend.f -- for centrosymmetric samples
C                NEUTRON densities version
C
C     MAXIMUM ENTROPY ELECTRON DENSITY ANALYSIS PROGRAM
C     for neutron powder or single crystal diffraction data
C     REFERENCE : J.APPL.CRYST. (1990) 23, 526-534
C               : J.APPL.CRYST. (1993) 26, 453-457 (MEED program)
C               : J.Appl.Cryst. (1993) 26, 159-165 (neutron version)
C               : K. Burger, Dissertation/thesis, Universitaet Tuebingen, 1997
C                 (published by Shaker, Aachen, Germany).
C     COPYRIGHT BY SHINTARO KUMAZAWA ( NAGOYA UNIVERCITY )
C     ALL RIGHT RESERVED.
C     modified and enhanced by K. Burger, Inst. fuer Kristallographie,
C     Universitaet Tuebingen, Charlottenstr. 33, D-72070 Tuebingen,
C     Germany. 
C     Free use for academic users.
C     See the Tuebingen web-pages: http://www.uni-tuebingen.de/uni/pki
C
C     - UPDATE LABEL -
C
C     VERSION 1.00  1990-04-24  BY SHINTARO KUMAZAWA
C      ORIGINAL PROGRAM, MEMTARO.FORT.
C     VERSION 1.10  1990-11-08  BY YOSHIKI KUBOTA
C      ADD PREFERED ORIENTATION CORRECTION VERSION.
C     VERSION 2.00  1991-10-16  BY SHINTARO KUMAZAWA
C      START MEED SYSTEM PROJECT.
C      CHANGE SYMMETRY TREATMENT AND SOME CALCULATION ALGORITHM.
C     VERSION 2.12  1991-10-25  BY SHINTARO.KUMAZAWA
C      BUG FIX & OPTIMIZE SOME CALCULATION ALGORITHM.
C     VERSION 3.00  1991-11-15  BY SHINTARO KUMAZAWA
C      MODIFIED BY USING OF MAU METHOD.
C     Data input now read free-format. Better handling of divergence errors 
C      - 12.1995 k.b.
C     Data output format changed  - K. Burger 3.1996
C     MaxEnt-routine optimized for velocity.
C      New COMMON variables: rhelp1,2,4,5,6(mref) for MAXENT-SUBROUTINE.
C      Changes within loop over maxent cycles.
C      Memorize FCAL and GCAL from last successful cycle in case of
C      divergence - K. Burger 3.96 
C     lambda is varied automatically: in case of divergence lambda=lambda*0.5
C      if cycle was successful: lambda is increased a bit.
C      Bug in MKASYM routine fixed: wrong results in the case of
C      different pixel resolution: NPIX(1)<>NPIX(2 or 3).
C      Translation vectors ITRS and ISUB now real numbers: RTRS and RSUB.
C      Program split into modules; no COMMON blocks any more. (k.b. 4.1996)
C     Built in test: if constraint changes too quickly (by more than 10 %),
C      then the cycle is recalculated.  - Dec. 1996, K. Burger
C     Fixed bug with constraint-value calculation with GOBS in first cyles.
C      Built in deviation Fcal-Fobs in sigma units in display of results. 
C      K.B. Aug./Sept. 1997
C     NEUTRON version March 1998 (K. Burger)
C
C     - CAUTION !! -
C
C     (1) IF YOU TRY A SAMPLE HAVING NO CENTRE OF SYMMETRY, YOU MUST
C         REMOVE THE COMMENT MARK, 'CENT'.
C         Also, calls to subroutines MKASYM, STRCTF,STRCTG,CALCON,MAXENT
C         have to be substituted to their corresponding ones CMKASYM,CSTRCF,
C         CSTRCG,CCALCON,CMAXENT
C           
C     (2) YOU MAY NOT USE AN OLD FORMAT MEM DATA SET.
C
C     (3) SUBROUTINES DATE & WATCH CAN BE ONLY USED BY FACOM COMPUTER.
C
C     - UNIT NUMBER OF DATA FILES -
C
C     10 : MEED DATA SET ( THIS IS POWLS6.EXE COMPATIBLE FORMAT. )
C     20 : DENSITY DATA SET ( THIS IS READABLE BY MECONT.EXE. )
C     30 : ANALYSIS DOCUMENT DATA SET
C     40 : SPACE GROUP DATA BASE 'SPGRA.DAT', OFFERED BY FUJIO IZUMI.
C          (needed in subroutine rdspg.f)
C
C====================================================================
C
C
      PROGRAM mend
C
C       PARAMETERS:
C       mref = max. number of reflections
C       masym = max. number of pixels in asymmetric unit of cell
C       mpix = max. number of pixels along one cell axis (resolution)
C       mhist = max. number of changes in lambda-parameter done by the user
C       alpha = Final value of constraint
C       denmin = minimal value of normalized density
C       mautosave = number of cycles, after which an automatic savig of the 
C               current density is done.
C
      IMPLICIT none
C
      integer*4 nasym,masym,ia
      integer mhist,mref,mpix,mautosave
      real*4 alpha,denmin
C
      PARAMETER ( mref= 50, masym=60000, mpix=65)
      PARAMETER ( mhist=50, mautosave=100 )
      PARAMETER ( alpha=1.0, denmin=1.0e-5 )
C
C     *** VARIABLES ***
C
C* - The list of F-constraints: h k l A B sigma(|F|) (phased reflections)
C* - The list of G-constraints: hkl-list + 1 Gobs and s(Gobs) (groups of refl.)
C*   IDX(1..3,1..nref) contains the hkl-indices of ALL reflections
C*   FOBS(1..2,1..nrefF) contains the A and B of F-constraints
C*   sigF(1..nrefF) contains the sigma(|F|)
C*   GOBS(mref) contains the mean |F| of G-constraints: GOBS(1..nrefG)
C*     NGRP(1..nrefG) contains the number of reflections in group j
C*     SIGG(1..nrefG) contains the sigma of Gobs of group j
C*     PMUL(1..nrefG+..) contains the multiplicity of reflections in groups
C*     PMULS(1..nrefG) contains the sum of the multiplicities of group j
C*   nrefF,nrefG contain the numbers of constraints: F, G
C*   nref=total number of reflections
C
C     *** variables connected with the scattering-density values in the 
C     asymmetric unit of the cell:
      real*4 RDEOp(masym),RDEOm(masym),     ! starting density (positive+neg.)
     +       RDENp(masym),RDENm(maSYM),     ! new density 
     +       RASYM(masym) 
C
C     *** variables connected with the coordinates of the pixels:
      integer NPIX(3),IASYM(3,masym)
C
C     *** variables connected with the structure factors given as input:
C     *** FOBS: unique reflections, GOBS: groups of non-unique refl.
      real*4 FOBS(2,mref),FCAL(2,mref),GCAL(mref),
     $    SIGF(mref),PROF(mref),GOBS(mref),SIGG(mref)
      real*4 tnref
      integer IDX(3,mref),NGRP(mref),nref,nrefF,nrefG
C
C     *** cell-constants and others:
      real*4 CELL(6),pop,rtasym
      integer jph,jpk,jpl
      real*4 pi,rad,ca,cb,cg,sa,sb,sg,
     $   da,db,dg,dv,sv,as,bs,cs,ga,gb,gg,rh,rk,rl,av,
     $   rdint,sumBp,sumBm,rtBp,rtBm
C
C     *** variables connected with the entropy-functions:
      real*4 rfact,wrfact,entsp,entsm,entj,qfunc,conf,cong,connew,
     $  delta,lambda
C
C     *** arrays to memorize lquantities of last successful cycle 
      real*4 FCALO(2,mref),GCALO(mref),confold,deltaold,rfacold,
     $  wrfacold,conold,congold
C
C     *** variables connected with symmetry operators:
      integer IROT(3,3,48),nsym,ncen,nsub
      real*4 RTRS(3,48),RSUB(3,4)
C
C     *** tables of cos- and sin-values for each reflection and pixel:
      real*4 RMIC(mref,masym)
      real*4 RMIS(mref,masym)
C
C     *** variables connected with lambda-history list:
      integer IHIST(MHIST),nhist
      real*4 FHIST(3,MHIST)
C
C     *** variables connected with multiplicities of reflections given as groups
C     of overlayd reflections (G_obs, G-constraints):
      real*4 PMUL(mref),PMULS(mref)
C
C     *** auxilary arrays for maxent subroutine
      real*4 RHELP1(mref),RHELP2(mref),RHELP3(mref)
C
C     *** auxilary array for mkasym subroutine
      integer IDE(0:mpix,0:mpix,0:mpix)
C
C     *** other variables:
      CHARACTER title*200,filmem*50,filden*50,fildoc*50,
     $          aspg*10
      character*10 APRIOR(2)
      character*5 AGSW(2)
      integer iprior,igsw,nyes,iptyp,nsg,nset,
     $  ierr,itcycl,ngsw,iref,nn,i,j,k,
     $  ncycl,iii,icycl,ibadruns,igoodcyc
C     integer ITODAY(4)
      DATA (APRIOR(J),J=1,2)/'FLAT.     ','FILE DATA. '/
      DATA (AGSW(J),J=1,2)/'F & G','  F  '/
C
C
 1090 format(2(3(I3,1X),2(1x,G15.8)))  ! for display of asym. unit pixels
 2010 FORMAT(BN,A50)                 ! for filenames
 2020 FORMAT(BN,I5)		     ! for input of yes/no=0/1
 3000 FORMAT(4(/' '))
 3010 FORMAT(/'   MMM            MMM   EEEEEEEEEEEEEEE   NNN       ',
     $   '  NNN   DDDDDDDDDD'/'   MMMMMM      MMMMMM   EEEEEEEEEE',
     $   'EEEEE   NNNN        NNN   DDDDDDDDDDDD'
     $  /'   MMM MMM    MMM MMM   EEE               NNNNN       NNN  ',
     $   ' DDD        DDD'
     $  /'   MMM  MMM  MMM  MMM   EEE               NNN N',
     $   'N      NNN   DDD         DDD'
     $  /'   MMM   MMMMMM   MMM   ',
     $   'EEEEEEEEEEEEEEE   NNN  NN     NNN   DDD          DDD'
     $  /'   MMM     MM     MMM   EEEEEEEEEEEEEEE   NNN   NN    ',
     $   'NNN   DDD          DDD'
     $  /'   MMM            MMM   EEE   ',
     $   '            NNN    NN   NNN   DDD         DDD'
     $  /'   MMM ',
     $   '           MMM   EEE               NNN     NN  NNN   DD',
     $   'D        DDD'
     $  /'   MMM            MMM   EEEEEEEEEEEEEEE ',
     $   '  NNN      NN NNN   DDDDDDDDDDDD'
     $  /'   MMM            MM',
     $   'M   EEEEEEEEEEEEEEE   NNN        NNNN   DDDDDDDDDD'
     $  /'   MaxEnt scattering density analysis program ',
     $  /  '   for neutron single crystal or powder diffraction data'
     $  // '   References:',
     $   /,'   J.Appl.Cryst. (1990) 23, 526-534'
     $   /,'   J.Appl.Cryst. (1993) 26, 159-165',
     $   /,'   K. Burger, thesis, Universitaet Tuebingen 1997.',
     $  /'   COPYRIGHT BY SHINTARO KUMAZ',
     $  'AWA (C) 1991, K. Burger 1998, ALL RIGHT RESERVED.',
     $  //'   MEND Version of K. Burger,'/'   Institut fuer',
     $  ' Kristallographie, Universitaet Tuebingen',
     $  /'   Charlottenstr. 33, D-72070 Tuebingen, Germany, ',
     $  ' (March a.d. 1998)'
     $  /,'   >> for centrosymmetric crystals, SINGLE PRECISION <<')
 3020 FORMAT(/' *********   INITIAL STATE OF MEED ANALYSIS   ******',
     $       '*************************',
     $        /A80, /A80,/ A40/
     $        /' MEND DATA FILE NAME     = ',A50
     $        /' DENSITY DATA FILE NAME  = ',A50
     $        /' DOCUMENT DATA FILE NAME = ',A50
     $       //' CELL CONSTANT = ',5(F8.3,','),F8.3
     $        /' SPACE GROUP   = ',A10,
     $          ' Bsum+=',f12.3,' Bsum-=',f12.3,
     $        /' P.O. CORRECT  = ',F10.5,'  ,  TYPE = ',I2,
     $         '  ,  VECTOR = ',2(I3,','),I3
     $        /' NUMBER OF PIXELS = ',I7,' / ',I7,'   (',2(I3,','),
     $         I3,' )'
     $       //' REFLECTIONS OF CONSTRAINT FUNCTION  F-TYPE = ',I4,
     $         ' , G-TYPE = ',I4
     $        /' INITIAL DENSITY DISTRIBUTION IS ',A
     $        /' THIS SESSION IS ANALYZED BY USING ',A,' CONSTRAINT.'
     $        /' TRIAL LAGRANGE MULTIPLIER  lambda = ',F10.7,'.')
 3030 FORMAT( '  con=',F18.5,' conf=',F15.4,' cong=',F15.4
     $        /' delt=',F18.5,'    R=',F15.4,'   wR=',F15.4)
 3040 FORMAT(  ' ent+=',F18.7,' ent-=',f18.7,' ents=',f18.7,
     $        /' entj=',F18.7,' lagr=',F18.7)
 3060 FORMAT(' CYCLES ',I5)
 3130 FORMAT(/' *********   WAIT A MOMENT ! THE PHASE MATRIX ',
     $       'TABLE IS CALCULATED. ******')
 3500 FORMAT(/ ' INPUT MEND FILE NAME     = ',$)
 3510 FORMAT(  ' INPUT DENSITY FILE NAME  = ',$)
 3520 FORMAT(  ' INPUT DOCUMENT FILE NAME = ',$)
 3530 FORMAT(  ' SELECT INITIAL DENSITY DATA TYPE.  0=FLAT, 1=',
     $       'READ IN FILE DATA : ',$)
 3540 FORMAT(  ' DO YOU USE G-CONSTRAINTS',
     $       ' IN THE CALCULATION ? (0=YES, 1=NO) : ',$)
 3550 FORMAT(  ' ARE YOU SURE ?  (0=YES, 1=NO) : ',$)
 3560 FORMAT(/' INPUT NCYCL. ( >0:ITERATION CYCLES , <0:CHANGE LAMD',
     $       'A , =0:EXIT )  : ',$)
C
C
C*** INPUT FILENAMES AND INITIAL CONDITIONS. ***
C
      WRITE(6,3010)
  201 WRITE(6,3500)
      READ(5,2010) filmem
      WRITE(6,3510)
      READ(5,2010) filden
  203 WRITE(6,3520)
      READ(5,2010) fildoc
      OPEN(30,FILE=FILDOC,FORM='FORMATTED',STATUS='UNKNOWN',
     $     ERR=203,ACCESS='SEQUENTIAL')
      WRITE(30,3010)
      WRITE(6,3530)
      READ(5,2020) iprior
      WRITE(6,3540)
      READ(5,2020) igsw
      WRITE(6,3550)
      READ(5,2020) nyes
      IF (nyes.NE.0) GO TO 201
C
C*** READ MEED DATA AND MAKE SOME CONSTANTS. ***
C
      ierr=0
206   CALL READMEM(filmem,title,CELL,pop,iptyp,jph,jpk,jpl,
     $  nsg,nset,NPIX,mpix,sumBp,sumBm,lambda,mref,nref,nrefF,nrefG,
     $  IDX,FOBS,SIGF,GOBS,SIGG,NGRP,PMUL,PMULS,ierr,igsw)
      if (ierr.ne.0) then 
        write(*,*) 'ERROR: MEM-file could not be opened: ',filmem
        write(*,*)'Please input a new name:'
        read(*,'(a)') filmem
        goto 206
      endif
C
      write(*,'(a,f9.4,a,f9.4)') 
     $ ' Scattering length sums: pos=',sumBp,'  neg=',sumBm
      CALL RDSPG(nsg,nset,aspg,nsym,ncen,nsub,
     $  IROT,RTRS,RSUB,CELL)
C
C     *** display of symmetry info ***
C     CALL dspsym(nsg,nset,aspg,nsym,ncen,nsub,
C    $  IROT,RTRS,RSUB,CELL)
C
      CALL PRECAL(jph,jpk,jpl,pi,rad,ca,cb,cg,sa,sb,sg,
     $   da,db,dg,dv,sv,as,bs,cs,ga,gb,gg,rh,rk,rl,av,
     $   rdint,sumBp,sumBm,rtBp,rtBm,CELL,NPIX)

      CALL POCOR(iptyp,pop,PROF,nref,mref,IDX,
     $	               as,bs,cs,ga,gb,gg,rh,rk,rl,pi)
C
C*** INITIALIZE DATA & OUTPUT INITIAL STATE. ***
C
  210 WRITE(6,3130)
      IF (iprior.EQ.0) THEN
         CALL MKASYM(0,masym,nasym,mpix,NPIX,
     $     IROT,RTRS,RSUB,nsym,ncen,nsub,
     $     RDENp,RDENm,rtasym,RASYM,rdint, IASYM,RMIC,
CENT $     RMIS,
     $     IDX,mref,nref,IDE,pi)
      ELSE
	 CALL READDEN(filden,masym,nasym,IASYM,RDENp,RDENm,rtBp,rtBm)
         CALL MKASYM(1,masym,nasym,mpix,NPIX,
     $     IROT,RTRS,RSUB,nsym,ncen,nsub,
     $     RDENp,RDENm,rtasym,RASYM,rdint, IASYM,RMIC,
CENT $     RMIS,
     $     IDX,mref,nref,IDE,pi)
      END IF
C     print *,' nsym,nsub,ncen'
C     print *,nsym,nsub,ncen,(npix(i),i=1,3)
C     write(*,'(12i5)') (((irot(i,j,k),I=1,3),j=1,3),
C    $  (nint(npix(i)*rtrs(i,k)),i=1,3),
C    $    k=1,nsym)
C     write(*,'(3i5)') ((nint(npix(i)*rsub(i,k)),i=1,3),k=1,nsub)
C     read(*,*) idummi
C
C     *****************************************
C     ***** do precalculations for maxent *****
C     *****************************************
C
      NHIST=0
      itcycl=1
      delta=-1.0D-9
C     *** set densities to zero if scattering sum is zero
      if (sumBp.le.0) then
         print *,'Positive density is set to zero '
         do ia=1,nasym
            RDENp(ia)=0.0
         end do
      endif
      if (sumBm.ge.0) then
         print *,'Negative density is set to zero '
         do ia=1,nasym
            RDENm(ia)=0.0
         end do
      endif
      if (sumBp.le.0 .and. sumBm.ge.0) 
     $  CALL PROEND(' Incorrect scattering length sums given!')
         
C     *** if only Fobs are given: ngsw=1
C     *** if Gobs are given: in the first cycle, ngsw=-1 and the Gobs are 
C     *** not considered in the maxent-process. This is because Gcal is 
C     *** zero for flat starting-density, and there would result a `divided
C     *** by zero' error in the MAXENT routine.
C     *** After the first cycle, ngsw is set 0 in this case.
      ngsw=1
      if (nrefG.gt.0) then
        if (iprior.eq.0) then
C         *** Gobs given and flat starting density in first cycle ***
          ngsw=-1
        else 
C         *** Gobs and non-flat starting density from file ***
          ngsw=0
        endif
      endif
C     *** rden --> rdeo; calculate and memorize F_calc ***
      CALL RENEW(masym,nasym,RDEOp,RDEOm,RDENp,RDENm)
      CALL STRCTF(masym,nasym,RDENp,RDENm
     $   ,RMIC
CENT $   ,RMIS
     $   ,RASYM,mref,nref,FCAL,sumBp,sumBm)
C     *** memorize FCAL
      DO 42 iref=1,nref
	 FCALO(1,iref)=FCAL(1,iref)
	 FCALO(2,iref)=FCAL(2,iref)
42    CONTINUE
C
      NN=nrefF
      IF (NGSW.le.0) THEN
         NN=NN+nrefG
      ENDIF
      tnref=float(NN)
      IF (NGSW.le.0) THEN
         CALL STRCTG( mref,nrefF,nrefG,FCAL,GCAL,
     $      PROF,NGRP,PMUL,PMULS)
C        *** memorize GCAL
         DO 43 iref=1,nrefG
 	   GCALO(iref)=GCAL(iref)
	   GCALO(iref)=GCAL(iref)
43       CONTINUE
      ENDIF
C
C     *** calculate constraint values ***
      CALL CALCON(ngsw,conf,cong,wrfact,rfact,connew,tnref,
     $   mref,nrefF,nrefG,FCAL,PROF,FOBS,SIGF,GCAL,GOBS,SIGG )
      conold=connew
C     *** calculate entropy-function values ***
      CALL CALFN(masym,nasym,entj,entsp,entsm,rtasym,
     $   RDENp,RDENm,RDEOp,RDEOm,RASYM,
     $   qfunc,lambda,connew)
C
C     *** output starting values ***
      DO 60 I=1,2
         NN=6
         IF (I.EQ.2) NN=30
         WRITE(NN,3020)
     $   title(1:80),title(81:160),title(161:200),
     $   filmem,filden,fildoc,(CELL(j),j=1,6),aspg,sumBp,sumBm,
     $   pop,iptyp,jph,jpk,jpl,
     $   nasym,NPIX(1)*NPIX(2)*NPIX(3),(NPIX(j),j=1,3),
     $   nrefF,nrefG,APRIOR(iprior+1),AGSW(igsw+1),lambda
         WRITE(NN,3030) connew,conf,cong,delta,rfact,wrfact
         WRITE(NN,3040) entsp,entsm,entsp+entsm,entj,qfunc
   60 CONTINUE
C
C     ************************************************************
C     *** MAXENT PROCESS ***
C     ************************************************************
C
C     ***** start of loop over all cycles of calculation *********
C
  220 WRITE(6,3560)
      READ(5,2020,ERR=220) ncycl
      IF (ncycl.LT.-100) then
C       *** start from the beginning ***
        GO TO 210
      elseif (ncycl.lt.0) then
C       *** input different lambda/alpha ***
        CALL HISTRY(itcycl,delta,alpha,lambda,nhist,
     $                  mhist,FHIST,IHIST,conold)
        goto 220
      elseif (ncycl.eq.0) then
C       *** stop calculations ***
        print *,
     $    'Do you really want to stop the calculation ? (0=yes)'
        iii=0
        read(5,2020) iii
        if (iii.ne.0) goto 220
C       *** stop and save density in file: ***
        goto 260 
      elseif (ncycl.gt. 0) then
C       *** normal case: positive number of cycles given ***
	icycl=1
        ibadruns=0
        igoodcyc=0
      endif
C
C     ***********************************************
C     ***** start of loop over NCYCL cycles *********
C     ***********************************************
C
240   continue
      if (ibadruns.gt.13) then
C        *** exit loop: save and display last sensible results ***
	 print *,'-------------------------------------------'
	 print *,'Exit with saving of data: divergence error!'
	 print *,'-------------------------------------------'
	 itcycl=igoodcyc
	 connew=conold
	 conf=confold
         cong=congold
	 delta=deltaold
	 rfact=rfacold
	 wrfact=wrfacold
C        *** take old density as result ***
	 do 245,ia=1,nasym
	    RDENp(ia)=RDEOp(ia)
	    RDENm(ia)=RDEOm(ia)
245      continue
         CALL STRCTF(masym,nasym,RDENp,RDENm
     $     ,RMIC
CENT $     ,RMIS
     $     ,RASYM,mref,nref,FCAL,sumBp,sumBm)
	 if (ngsw.eq.0) CALL STRCTG(mref,nrefF,nrefG,FCAL,GCAL,
     $                     PROF,NGRP,PMUL,PMULS)
	 goto 260
      endif
C
C ************************
C
      CALL MAXENT(ngsw,mref,nrefF,nrefG,masym,nasym,rtasym
     $  ,FOBS,FCAL,PROF,SIGF,NGRP,GOBS,GCAL,SIGG,tnref,lambda
     $  ,RMIC
CENT $  ,RMIS
     $  ,PMUL,PMULS,RDEOp,RDEOm,RDENp,RDENm,
     $   RHELP1,RHELP2,RHELP3,denmin,sumBp,sumBm,rtBp,rtBm)
C
C ************************
C
      CALL NORMAL(masym,nasym,RDENp,RDENm,RASYM,rtasym)
      CALL STRCTF(masym,nasym,RDENp,RDENm
     $ ,RMIC
CENT $ ,RMIS
     $ ,RASYM,mref,nref,FCAL,sumBp,sumBm)
      if (ngsw.le.0) CALL STRCTG( mref,nrefF,nrefG,FCAL,GCAL,
     $                            PROF,NGRP,PMUL,PMULS)
      CALL CALCON(ngsw,conf,cong,wrfact,rfact,connew,tnref,
     $  mref,nrefF,nrefG,FCAL,PROF,FOBS,SIGF,GCAL,GOBS,SIGG )
      delta=connew-conold
C
      WRITE(6,3060) itcycl
      WRITE(6,3030) connew,conf,cong,delta,rfact,wrfact
      IF (delta.GE.0.0 .or. 
     +    ABS(delta/conold).gt.0.1 ) then
C        *** divergence error: choose new lambda and restart calc. ***
C        *** or: at start of calculation too large step in contstraint
	 ibadruns=ibadruns+1
	 lambda=lambda/2
         nhist=nhist+1
	 if (nhist.gt.mhist) nhist=mhist
         FHIST(1,nhist)=lambda*2
         FHIST(2,nhist)=lambda
         FHIST(3,nhist)=conold
         IHIST(nhist)=itcycl
         write(*,'(a,i3,a,f13.8)') 'Bad cycles number:',ibadruns,
     $    '   New lambda=',lambda
C        *** call back F_cal, G_cal of last successful cycle ***
C        *** nref=nrefF + (No. of reflections in groups) ***
         DO 242 iref=1,nref
  	   FCAL(1,iref)=FCALO(1,iref)
	   FCAL(2,iref)=FCALO(2,iref)
242      CONTINUE
         IF (NGSW.le.0) THEN
           DO 243 iref=1,nrefG
             GCAL(iref)=GCALO(iref)
	     GCAL(iref)=GCALO(iref)
243        CONTINUE
         ENDIF
C        *** restart calculation with changed lambda ***
         GO TO 240
      ENDIF 
C     *** this cyle was successful: delta < 0 ***
C     *** new density rden --> rdeo ***
      CALL RENEW(masym,nasym,RDEOp,RDEOm,RDENp,RDENm)
C     *** increase lambda a bit ***
      lambda=lambda*1.02
C     *** memorize a lot of this cycle ***
      ibadruns=0
      igoodcyc=itcycl
      confold=conf
      congold=cong
      deltaold=delta
      rfacold=rfact
      wrfacold=wrfact
      DO 252 iref=1,nref
         FCALO(1,iref)=FCAL(1,iref)
	 FCALO(2,iref)=FCAL(2,iref)
252   CONTINUE
      IF (ngsw.le.0) THEN
         DO 253 iref=1,nrefG
 	   GCALO(iref)=GCAL(iref)
	   GCALO(iref)=GCAL(iref)
253      CONTINUE
      ENDIF
C     *** increase cycle counters ***
      itcycl=itcycl+1
      icycl=icycl+1
C     *** SAVE DENSITY DATA after every xxth cycle ***
      if (mod(itcycl-1,mautosave).eq.0) then
         print *,'Automatically saving density data ...'
	 CALL SAVEDEN(filden,
     $      masym,nasym,title,IASYM,RDENp,RDENm,CELL,NPIX
     $      ,nsym,ncen,nsub,IROT,RTRS,RSUB,rtBp,rtBm )
      endif
C
      IF (connew.LE.ALPHA) then
C        *** calculation finished ***  
	 GO TO 260
      endif
      conold=connew
      IF (ngsw.EQ.-1) ngsw=0
      IF (icycl.LE.ncycl) GO TO 240
C
C     ***** end of loop over NCYCL cycles *********
C
C     CALL DSPTIM(6,itcycl)
      GO TO 220
C
C     ==========================================================
C     ***** end of loop over all cycles of calculation *********
C     ==========================================================
C
C     **********  DISPLAY & OUTPUT ANALYSIS RESULT.  ***********
C
260   write(6,3000)
      itcycl=itcycl-1
C
C*** SAVE DENSITY DATA. ***
C
      CALL SAVEDEN(filden,
     $  masym,nasym,title,IASYM,RDENp,RDENm,CELL,NPIX
     $  ,nsym,ncen,nsub,IROT,RTRS,RSUB,rtBp,rtBm )
C
C*** CALCULATE ENTROPY-FUNCTIONS
      CALL CALFN(masym,nasym,entj,entsp,entsm,rtasym,
     $   RDENp,RDENm,RDEOp,RDEOm,RASYM,
     $   qfunc,lambda,connew)
C
C*** DISPLAY INTO STANDARD OUTPUT ***
      CALL DSPRESUL(6,
     $  connew,conf,cong,delta,rfact,wrfact,entsp,entsm,entj,qfunc,
     $  IHIST,FHIST,mhist,nhist,iptyp,itcycl,
     $  mref,nrefF,nrefG,FOBS,FCAL,SIGF,PROF,
     $  NGRP,GOBS,GCAL,SIGG,IDX)
C
C*** DISPLAY INTO DOCUMENT FILE ***
      CALL DSPRESUL(30,
     $  connew,conf,cong,delta,rfact,wrfact,entsp,entsm,entj,qfunc,
     $  IHIST,FHIST,mhist,nhist,iptyp,itcycl,
     $  mref,nrefF,nrefG,FOBS,FCAL,SIGF,PROF,
     $  NGRP,GOBS,GCAL,SIGG,IDX)
C
C*** DISPLAY FIRST DENSITY VALUES
      write(*,*) 'First 10 values of density:'
      write(30,*) 'First 10 values of density:'
      do i=1,10
        write(*,1090) 
     $  (iasym(j,i),j=1,3),rtBp*RDENp(i),rtBm*RDENm(i)
        write(30,1090) 
     $  (iasym(j,i),j=1,3),rtBp*RDENp(i),rtBm*RDENm(i)
      end do
      CLOSE(30)
      print *
C
C*** END OF PROGRAM ***
C
      STOP
      END
